#ifdef TS5
#define TS_CURRENT  5   /* current TS protocol version */
#else
#define TS_CURRENT  3   /* current TS protocol version */
#endif

#ifdef TS5_ONLY
#define TS_MIN      5   /* minimum supported TS protocol version */
#else
#define TS_MIN      3   /* minimum supported TS protocol version */
#endif


static char *months[] =
{
        "January",
        "February",
        "March",
        "April",
    "May",
        "June",
        "July",
        "August",
    "September",
        "October",
        "November",
        "December"
};

static char *weekdays[] =
{
        "Sunday",
        "Monday",
        "Tuesday",
        "Wednesday",
    "Thursday",
        "Friday",
        "Saturday"
};

typedef struct _ircd_mode               IRCD_MODE;
typedef struct _ircd_capab              IRCD_CAPAB;

struct _ircd_mode
{
        char                            mode;
        char                            plusminus;
        IRCD_CLIENT                     *cptr;    
       
        char                            *banstring;
        char                            *exceptstring;  /* all three of these variables could probably share the same space, it might */
        char                            *quietstring;   /* be worth coming back and setting it up that way ...... later */              
       
        IRCD_MODE                       *next;
};                                            

struct _ircd_capab
{
        int                                     value;
        char                            *name;        
        int                                     flags;
};     

int hostname_check(char *hostname)
{
	char *tptr = hostname;
	char *dotptr = NULL;

	for(;*tptr;tptr++)
	{
		if ((*tptr <= ' ') || (*tptr > 'z') || (*tptr == ':') ||
				(*tptr == '*') || (*tptr == '%'))
			break;
		if (*tptr == '.')
			dotptr = tptr;
	}
	if (*tptr || !*hostname || !dotptr || (strlen(dotptr) > 4))
		return 0;

	return 1;
}

int nickname_check(char *nick)
{
	char	*ch;

	if ((*nick == '-') || isdigit(*nick))
		return 0;
	for (ch = nick; *ch && (ch - nick) < NICKLEN; ch++)
		if (!isvalid(*ch) || isspace(*ch))
			break;
	*ch = '\0';
	return (ch - nick);
}

IRCD_USERFLAG _user_flags[] =
{
	{ CLIENT_NFLAGS_OWALLOPS,			"OWALLOPS",			1	},
	{ CLIENT_NFLAGS_SWALLOPS,			"SWALLOPS",			1	},
	{ CLIENT_NFLAGS_STATSNOTICES,			"STATSNOTICES",			1	},
	{ CLIENT_NFLAGS_OKILLS,				"OKILLS",			1	},
	{ CLIENT_NFLAGS_SKILLS,				"SKILLS",			1	},
	{ CLIENT_NFLAGS_SNOTICES,			"SNOTICES",			0	},
	{ CLIENT_NFLAGS_CLICONNECTS,			"CLICONNECTS",			1	},
	{ CLIENT_NFLAGS_CLIDISCONNECTS,			"CLIDISCONNECTS",		1	},
	{ CLIENT_NFLAGS_THROTTLES,			"THROTTLES",			1	},
	{ CLIENT_NFLAGS_NICKCHANGES,			"NICKCHANGES",			1	},
	{ CLIENT_NFLAGS_IPMISMATCHES,			"IPMISMATCHES", 		1	},
	{ CLIENT_NFLAGS_LWALLOPS,			"LWALLOPS",			1	},
	{ CLIENT_NFLAGS_CONNECTS,			"CONNECTS",			1	},
	{ CLIENT_NFLAGS_SQUITS,				"SQUITS",			1	},
	{ CLIENT_NFLAGS_GLINEEXPIRES,			"EXPIREDGLINES",		1,	},
#if 0
	{ CLIENT_NFLAGS_GLINES,			"GLINES",		1, 	}, 
#endif
	{ CLIENT_NFLAGS_INVISIBLE,		"INVISIBLE",		0	},
	{ CLIENT_NFLAGS_DEAF,			"DEAF",			0	},
	{ CLIENT_NFLAGS_ONLYREGISTEREDMSGS,	"ONLYREGISTEREDMSGS", 	0	},
	{ 0, NULL, 0 }
};

int _user_modes[] =
{
	CLIENT_UMODES_OPER,			'o',
	CLIENT_UMODES_LOCOP,		'O',
	CLIENT_UMODES_FMODE,		'f',
	CLIENT_UMODES_IMODE,		'i',
	CLIENT_UMODES_KMODE,		'k',
	CLIENT_UMODES_SMODE,		's',
	CLIENT_UMODES_WMODE,		'w',
	CLIENT_UMODES_ZMODE,		'z',
	CLIENT_UMODES_YMODE,		'y',
	CLIENT_UMODES_CMODE,		'c',
	CLIENT_UMODES_NMODE,		'n',
	CLIENT_UMODES_SERVICE,		'x',
	CLIENT_UMODES_REGISTERED,	'r',
	CLIENT_UMODES_ONLYREGMSGS,	'R',
	CLIENT_UMODES_DEAF,		'd',
	0, 0
};

int _channel_modes[] =
{
	CHANNEL_MODES_PRIVATE,		'p',
	CHANNEL_MODES_SECRET,		's',
	CHANNEL_MODES_MODERATED,	'm',
	CHANNEL_MODES_NOPRIVMSGS,	'n',
	CHANNEL_MODES_TOPICLIMIT,	't',
	CHANNEL_MODES_INVITEONLY,	'i',
	CHANNEL_MODES_OPERONLY,		'O', /* adopted from DALnet */
	CHANNEL_MODES_REGGEDONLY,	'R', /* also adopted from there, only few modes i liked */
	0, 0
};
